Subject: Re: bug#44660: [feature/native-comp] defalias to macro in compiled elisp seems to not work in smartparens

From: Jim Myhrberg <[email-masked]>
Date: Sun, 15 Nov 2020 22:32:42 +0000

Hi Andrea,

Yep, it does indeed fix it. I assume it's related to byte compilation
then, and not native-comp? Thanks for your quick response, and I'm
sorry for wasting your time with this :(

On Sun, Nov 15, 2020 at 8:42 PM Andrea Corallo <[email-masked]> wrote:
>
> Jim Myhrberg <[email-masked]> writes:
>
> > Hi,
> >
> > After the following pull request was merged:
> > https://github.com/Fuco1/smartparens/pull/958
> >
> > I started getting this error:
> >
> >     Error running timer ‘sp-show--pair-function’: (invalid-function
> > sp--while-no-input)
> >
> > The offending code seems to be:
> >
> >     (defalias 'sp--while-no-input 'while-no-input)
> >
> > And then later the call to "sp--while-no-input" within the
> > "sp-show--pair-function" function. If I manually eval the
> > "sp-show--pair-function" so it's no longer a natively compiled
> > function, things start working again.
> >
> > For now in my personal config (which is not native-compiled), I've
> > resorted to this work-around which seems to work:
> >
> >     (defun sp--while-no-input (&rest body)
> >       (eval (append '(while-no-input) body)))
> >
> > Thanks again :)
>
> Hi Jim,
>
> does the attached patch to smartparens.el fix the issue?
>
> Ciao!
>
>   Andrea
>